/*
 * ------------------------------------------------------------------------------
 *
 * Interface to Philips ISP1301 USB OTG transceiver 
 *
 * (C) 2006 Jochen Karrer 
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 * ------------------------------------------------------------------------------
 */

#include <i2c.h>
#include <stdint.h>
I2C_Slave * ISP1301_New(char *name);

/* Lazy direct access */
typedef struct ISP1301  ISP1301;
void ISP1301_Write(ISP1301 *isp,uint8_t data,uint8_t addr);
uint8_t ISP1301_Read(ISP1301 *isp,uint8_t addr);
ISP1301 * ISP1301_GetPtr(I2C_Slave *slave);
